#Include "MiniGui.ch"
#include "hbsqlit3.ch"



Procedure Main()
   Private Db := Nil
   
	Db := sqlite3_open( "test.db", .t. )
	if empty(db)
		msgbox("Can't Create/Open Test.db")
		return
	endif
   
   SET NAVIGATION EXTENDED

   DEFINE WINDOW frmMain ;
      AT 5,5 ;
      WIDTH 640 ;
      HEIGHT 480;
      TITLE "HMG SQLite Project 001" ;
      MAIN ;
      NOSIZE ;
      NOMINIMIZE ;
      BACKCOLOR GRAY ;
      ON INIT {|| frmMain.StatusBar.Item(1) := "SQLite Database opened!!!"}
//      ON RELEASE {|| sqlite3_close(db)}

      DEFINE STATUSBAR
      STATUSITEM " "
      END STATUSBAR

      DEFINE MAIN MENU
         POPUP "&File"
            Item "E&xit"               action thiswindow.release()
         end popup
         popup "&Entry"
            item "&Customer"           action cust()
         end popup
      END MENU

   END WINDOW

   MAXIMIZE WINDOW frmMain
   ACTIVATE WINDOW frmMain

Return Nil




Function Cust()

   if isWindowDefined(frmCust)
      return nil
   endif

   wait window "Preparing Database ..." nowait
   prepare_data()
   wait clear

   define window frmCust ;
      at 0, 0 width 600 height 500 ;
      title "Customer" ;
      child ;
      on init get_data() ;
      on size form_resize()


      DEFINE STATUSBAR
      STATUSITEM "Ins: Add new, Dbl-Click: Edit, Del: Delete"
      END STATUSBAR


      @ 0, 0 grid grdCust ;
         width 400 height 300 ;
         HEADERS { 'Code', 'Name' } ;
         WIDTHS { 100, 200 } ;
         justify { 0, 0} ;
         on dblclick CustChange(.f.)
   end window
   on key INSERT of frmCust            action CustChange(.t.)
   on key DELETE of frmCust            action del_cust()
   frmCust.center
   frmCust.activate

return nil



function get_data()
   local aRec := {}, i
   aRec := SQLITE_QUERY(Db, "select custcd, custnm from cust order by custnm")
   frmCust.grdCust.DeleteAllItems()
   for i := 1 to len(aRec)
      frmCust.grdCust.additem(aRec[i])
   next
   form_resize()
return nil



function del_cust()
   local lineno, mCustcd, mCustnm
   lineno := frmCust.grdCust.value
   if lineno < 1
      return nil
   endif
   mCustcd := frmCust.grdCust.cell(lineno, 1)
   mCustnm := frmCust.grdCust.cell(lineno, 2)
   if  lineno > 0 .and. msgyesno("Do you really delete "+alltrim(mCustnm)+" ?")
      if MiscSql(Db, "delete from cust where custcd = '"+alltrim(mcustcd)+"';")
         frmCust.grdCust.deleteitem( lineno )
         if lineno > 1
            frmCust.grdCust.value := lineno -1
         else
            if frmCust.grdCust.itemcount > 0
               frmCust.grdCust.value := 1
            endif
         endif
      endif
   endif
return nil




Function  CustChange( lAddmode )
   local linino, mCustcd, mCustnm
   lineno := iif(lAddmode, frmCust.grdCust.itemcount+1, frmCust.grdCust.value)
   if lineno < 1
      return nil
   endif

   mCustcd := iif(lAddmode, "", frmCust.grdCust.cell(lineno, 1))
   mCustnm := iif(lAddmode, "", frmCust.grdCust.cell(lineno, 2))

   DEFINE WINDOW frmCustChange ;
      AT 0,0 ;
      WIDTH 485 HEIGHT 240 ;
      TITLE iif( lAddmode , "Add new Customer" , "Modify Customer record" )  ;
      MODAL ;
      NOSYSMENU

      @ 20, 30 LABEL lblCustcd ;
         VALUE "Code:"

      @ 20, 130 textbox txtCustcd ;
         value mCustcd ;
         inputmask "!!!!!!!!!!"

      @ 50, 30 LABEL lblCustnm ;
         VALUE "Name:"

      @ 50, 130 textbox txtCustnm ;
         value mCustnm ;
         width 200


      @ 165,100 BUTTON cmdConfirm ;
         CAPTION '&Confirm' ;
         ACTION SaveRecord( lineno, lAddmode )

      @ 165,300 BUTTON cmdCancel ;
         CAPTION '&Cancel' ;
         ACTION frmCustChange.Release

   END WINDOW

   frmCustChange.txtCustcd.enabled := lAddmode
   frmCustChange.center
   frmCustChange.activate
Return Nil



function SaveRecord(lineno, lAddmode)
   local mCustcd, mCustnm
   mCustcd := frmCustChange.txtCustcd.value
   mCustnm := frmCustChange.txtCustnm.value
   if empty(mCustcd)
      msgbox("Customer code cannot be blank!")
      return nil
   endif
   if empty(mCustnm)
      msgbox("Customer name cannot be blank")
      return nil
   endif
   if lAddmode
      if MiscSql(Db, "insert into cust (custcd, custnm) values ('"+mcustcd+"', '"+mcustnm+"');")
         frmCustChange.release()
         frmCust.grdCust.additem({mcustcd, mcustnm})
         frmCust.grdCust.value := frmCust.grdCust.itemcount
         return nil
      endif
   else
      if MiscSql(Db, "update cust set custnm = '"+mcustnm+"' where custcd = '"+mcustcd+"';")
         frmCustChange.release()
         frmCust.grdCust.item(lineno) := {mCustcd, mCustnm}
         return nil
      endif
   endif
return nil	







function form_resize()
   frmCust.grdCust.col := 0
   frmCust.grdCust.row := 0
   frmCust.grdCust.width := frmCust.width-10
   frmCust.grdCust.height := frmCust.height-50
return nil





Function Prepare_data()
   local i, aTemp := {}, sQuery := ""
	MiscSql(Db, "CREATE TABLE IF NOT EXISTS cust"+ ;
         " ( Custcd VARCHAR(10) NOT NULL,  Custnm  VARCHAR(40) NOT NULL, PRIMARY KEY (Custcd)) ;")
   MiscSql(Db, "CREATE UNIQUE INDEX IF NOT EXISTS Custnm  on cust(Custnm);")
   aTemp := SQLITE_QUERY(db, "select * from cust;")
   if len(aTemp) = 0
      for i = 1 to 100
      	sQuery += "insert into cust (custcd, custnm) values ('CUST "+str(i, 3)+"', 'Customer "+str(i, 3)+"'); "
      next
      sQuery = "BEGIN TRANSACTION; "+ sQuery + "COMMIT;"
      MiscSql(db, sQuery)
   endif     
Return Nil



Function MiscSql(mDb, mStr)
	local cError, n
	n := sqlite3_exec(mDb, mStr)
	if n == 0
		return .t.
	endif
	cError := sqlite3_errmsg(mDb)
	if !empty(cError)
		msgbox(cError)
	endif
	return .f.

*-------------------------------------
 FUNCTION SQLITE_TABLEEXISTS( cTable )
*---------------------------------------------------------------------------
* Uses a (special) master table where the names of all tables are stored
*---------------------------------------------------------------------------
  LOCAL cStatement, lRet := .f.
  LOCAL lCreateIfNotExist := .f.
  LOCAL db := sqlite3_open( "test.db", lCreateIfNotExist )

  cStatement := "SELECT name FROM sqlite_master "    +;
                "WHERE type ='table' AND tbl_name='" +;
                cTable + "'"

  IF DB_IS_OPEN( db )
    lRet := ( LEN( SQLITE_QUERY( db, cStatement ) ) > 0 )
  ENDIF

RETURN( lRet )


*---------------------------------
 FUNCTION SQLITE_FIELDS( cTable )
*---------------------------------------------------------------------------
* Returns an unidimensional array with field names only
*---------------------------------------------------------------------------
  LOCAL aFields := {}, cStatement := "SELECT * FROM " + cTable
  LOCAL lCreateIfNotExist := .f.
  LOCAL db := sqlite3_open( "test.db", lCreateIfNotExist )
  LOCAL stmt, nCCount, nI

  stmt := sqlite3_prepare( db, cStatement )

  sqlite3_step( stmt )
  nCCount := sqlite3_column_count( stmt )  

  IF nCCount > 0
	FOR nI := 1 TO nCCount
	        AADD( aFields, sqlite3_column_name( stmt, nI ) )
	NEXT nI
  ENDIF

  sqlite3_finalize( stmt )

RETURN( aFields )

*--------------------------------
 FUNCTION SQLITE_COLUMNS( cTable )
*---------------------------------------------------------------------------
* Returns an 2-dimensional array with field names and types
*---------------------------------------------------------------------------
  LOCAL aCType :=  { "SQLITE_INTEGER", "SQLITE_FLOAT", "SQLITE_TEXT", "SQLITE_BLOB", "SQLITE_NULL" }
  LOCAL aFields := {}, cStatement := "SELECT * FROM " + cTable
  LOCAL stmt, nCCount, nI, nCType

  stmt := sqlite3_prepare( db, cStatement )

  sqlite3_step( stmt )
  nCCount := sqlite3_column_count( stmt )  

  IF nCCount > 0
	FOR nI := 1 TO nCCount
		nCType := sqlite3_column_type( stmt, nI )
	        AADD( aFields, { sqlite3_column_name( stmt, nI ), aCType[ nCType ] } )
	NEXT nI
  ENDIF

  sqlite3_finalize( stmt )

RETURN( aFields )

*------------------------
 FUNCTION SQLITE_TABLES()
*---------------------------------------------------------------------------
* Uses a (special) master table where the names of all tables are stored
* Returns an array with names of tables inside of the database
*---------------------------------------------------------------------------
  LOCAL aTables, cStatement

  cStatement := "SELECT name FROM sqlite_master "      +;
                "WHERE type IN ('table','view') "      +;
                "AND name NOT LIKE 'sqlite_%' "        +;
                "UNION ALL "                           +;
                "SELECT name FROM sqlite_temp_master " +;
                "WHERE type IN ('table','view') "      +;
                "ORDER BY 1;"

  IF DB_IS_OPEN( db )
    aTables := SQLITE_QUERY( db, cStatement )
  ENDIF

RETURN( aTables )


*--------------------------------------
 FUNCTION SQLITE_QUERY( db, cStatement )
*---------------------------------------------------------------------------
  LOCAL stmt, nCCount, nI, nCType
  LOCAL aRet := {}, aRec := {}

  stmt := sqlite3_prepare( db, cStatement )
                
  IF STMT_IS_PREPARED( stmt )
    DO WHILE sqlite3_step( stmt ) == SQLITE_ROW
    	aRec := {}
	nCCount := sqlite3_column_count( stmt )  

	IF nCCount > 0
		FOR nI := 1 TO nCCount
			nCType := sqlite3_column_type( stmt, nI )

			SWITCH nCType
				CASE SQLITE_NULL
				        AADD( aRec, "NULL")
					EXIT
		
				CASE SQLITE_FLOAT
				CASE SQLITE_INTEGER
				        AADD( aRec, LTRIM(STR( sqlite3_column_int( stmt, nI ) )) )
					EXIT

				CASE SQLITE_TEXT
			        	AADD( aRec, sqlite3_column_text( stmt, nI ) )
					EXIT
			END SWITCH
		NEXT nI
	ENDIF
		aadd(aRet, aRec)
    ENDDO
    sqlite3_finalize( stmt )
  ENDIF
  
RETURN( aRet )

